/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author: brianpc.huang $
 * $Date: 2015/05/29 $
 * $RCSfile: ir_ph.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/

#ifndef IR_PH_H
#define IR_PH_H

#include "x_lint.h"
#include "x_typedef.h"

/* standard ansi c __attribute__((packed))  */
LINT_SUPPRESS_BRACE(950)
typedef union
{
	UINT32 u4MtCode;
	struct
	{
		UINT32 tail			:  4;
		UINT32 command		: 12;
		UINT32 address		: 10;
		UINT32 toggle		:  2;
		UINT32 start		:  4;
	} u;
} __attribute__ ((packed)) RC5_RAW_T;

/* standard ansi c __attribute__((packed))  */
LINT_SUPPRESS_BRACE(950)
typedef union
{
	UINT32 u4Rc5Code;
	struct
	{
		UINT32 reserved		: 2;
		UINT32 command		: 6;
		UINT32 address		: 5;
		UINT32 toggle		: 1;
		UINT32 start		: 2;
	} u;
} __attribute__ ((packed)) RC5_SPLITTER_T;

/* standard ansi c __attribute__((packed))  */
LINT_SUPPRESS_BRACE(950)
typedef union
{
	UINT32 u4Rc6Mode0Code;
	struct
	{
		UINT32 tail			: 9;
		UINT32 command		: 8;
		UINT32 address		: 8;
		UINT32 toggle		: 2;
		UINT32 mb			: 3;
		UINT32 start		: 2;
	} u;
} __attribute__ ((packed)) RC6_SPLITTER_T;

/* macros */
#define SCREEN_LO	(0x55555555)
#define BITMASK_LO(bits) ( (bits >= 32) ? 0xffffffff : ((1 << (bits)) - 1) )

EXTERN UINT8 IR_PH_ReverseBit8(UINT8 u1Input);
EXTERN UINT16 IR_PH_ReverseBit16(UINT16 u2Input);
EXTERN UINT32 IR_PH_ReverseBit32(UINT32 u4Input);
EXTERN UINT32 IR_PH_BiPhase(UINT32 u4Input, UINT32 u4Bits);

/* rc5 decoder */
EXTERN BOOL IR_PH_BiPhaseTest(UINT8 u1Bits, UINT32 u4Val);
EXTERN UINT32 IR_PH_Rc5BiPhaseDecode(UINT8 u1Bits, UINT32 u4BiPhase);
EXTERN UINT32 IR_PH_Mt2Rc5Shift(UINT8 u1Bits, UINT32 u4MtCode);
EXTERN UINT32 IR_PH_Mt2Rc5Decode(UINT32 u4MtCode);
EXTERN void IR_PH_Rc5Split(UINT32 u4Rc5Code, UINT32 *pu4Start, UINT32 *pu4Toggle,
	UINT32 *pu4Address, UINT32 *pu4Command);
EXTERN BOOL IR_PH_Rc5Validate(UINT8 u1Bits, UINT32 u4MtCode, UINT32 u4Rc5Code);

/* rc6 decoder */
EXTERN UINT32 IR_PH_Mt2Rc6Decode(UINT32 u4MtCode);
EXTERN void IR_PH_Rc6Split(UINT32 u4Rc6Code, UINT32 *pu4Start, UINT32 *pu4Mb, UINT32 *pu4Toggle,
	UINT32 *pu4Address, UINT32 *pu4Command);
EXTERN BOOL IR_PH_Rc6Validate(UINT8 u1Bits, UINT32 u4MtCode, UINT32 u4Rc6Code);



#endif /* IR_PH_H */
