/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*-----------------------------------------------------------------------------
 *
 * $Author: victor.zhuo $
 * $Date: 2016/07/16 $
 * $RCSfile: drv_tnri.h,v $
 * $Revision: #1 $
 *
 *---------------------------------------------------------------------------*/
/** @file drv_tnr.h
 *  Brief of file drv_tnr.h.
 *  Details of file drv_tnr.h (optional).
 */

#ifndef DRV_TNR_H
#define DRV_TNR_H

//////////////////////////////////////////////////////////////////////////////// 
// Include files
//////////////////////////////////////////////////////////////////////////////// 

#include "x_typedef.h"
#include "general.h"
#include "feature.h"
#include "drv_tdtv_drvif.h"
#include "vdp_if.h"
#include "vdo_rm.h"
////////////////////////////////////////////////////////////////////////////////
// FW PORTING CFG , SHOULD BE REMOVE ON IC
////////////////////////////////////////////////////////////////////////////////


#define TNR_READ_FLD(u2Addr, u4Fld) \
     IO32ReadFldAlign(u2Addr, u4Fld)

//#ifndef LOG_MDDI_REG
#define TNR_WRITE_FLD(u2Addr, u4Value, u4Fld) \
    vIO32WriteFldAlign(u2Addr, u4Value, u4Fld)

#define TNR_WRITE32_MSK(u2Addr, u4Value,  u4Msk) \
    vIO32Write4BMsk(u2Addr, u4Value, u4Msk)
//#else
//void TNR_WRITE_FLD(UINT8 u1VdpId, UINT16 u2Addr, UINT32 u4Value, UINT32 u4Fld);
//void TNR_WRITE32_MSK(UINT8 u1VdpId, UINT16 u2Addr, UINT32 u4Value, UINT32 u4Msk);
//#endif


#define TNR_SET_RES_CNT_DOWN 40
#define TNR_CLOCK 648000000

typedef struct {
    UINT8 u1OnOff;
    UINT8 u18bit;
    UINT8 u1fg422;
    UINT16 u2BufWidth;
    UINT16 u2BufHeight;
    UINT32 u4BufSize;
    UINT32 u4BufAddr;
}TNR_STATIC_STATE;

typedef struct
{
    UINT16 u2Width;
    UINT16 u2Height;
}TNR_SET_RES_STATE;

typedef struct
{
    UINT8 u1SetResCnt;
}TNR_DYN_VAR;
//global variable which doesn't cuse modechange or set resolution


void  vDrvTNRChkImpl(void);



/**
 * @brief TNR SRM callback function
 * @param u4Arg1 VDP_1/VDP_2
 * @param u4Arg2 configuration
 * @param u4SramMode sram mode
 */
void vDrvTNRSrmCb(UINT32 u4VdpId, UINT32 u4SrmMode, UINT32 u4PDSize, UINT32 u4TDTV);


/**
 * @brief Initialize PSCAN register values
 * @param u1VdpId VDP_1/VDP_2
 */
void vDrvTNRSwInit(void);
void vDrvTNRHwInit(void);

void vDrvTNRSetFrameBuf(void);
void vDrvTNRSetMIBModeChangeFlag(UINT8 u1OnOff);
void vDrvTNRSwitch(UINT8 u1OnOff);

void vDrvTNRSwInit(void);
void vDrvTNRHwInit(void);
void vDrvNRSetMDPTNROnOff(UINT8 u1OnOff);
void vDrvNRSetMDPTNRParam(void);
void vDrvTNRSetDemoRange(UINT8 bOnOff, UINT8 bRegion, UINT16 wXCenter);
UINT8 vDrvIsTnrOnoff(void);

#ifdef CC_SUPPORT_STR
//-----------------------------------------------------
//
// MIB ( DI/NR ) 
// added for MIB suspend/resume  function
//-----------------------------------------------------
void vDrvTNRSuspend(void);
void vDrvTNRResume(void);
#endif


#endif    // DRV_TNR_H
