/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @file x_opera_hbbtv_dvb.h 
 *  $RCSfile: $
 *  $Revision: #3 $
 *  $Date: 2016/02/05 $
 *  $Author: defu.zhen $
 *  
 *  @par Description: This header file declares HBBTV exported APIs.
 */
/*----------------------------------------------------------------------------*/
#ifndef _X_OPERA_HBBTV_DVB_H_
#define _X_OPERA_HBBTV_DVB_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "u_common.h"
#include "u_handle.h"
#include "u_opera_hbbtv.h"
#include "u_opera_hbbtv_dvb.h"
#include "u_opera_hbbtv_common.h"
#include "u_sm_video_hdlr.h"
#include "u_edb.h"

/*-----------------------------------------------------------------------------
                    macros, defines, typedefs, enums
-----------------------------------------------------------------------------*/


/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_set_video_region
 *
 * Description: This function will set video source region (for opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_set_video_region (
                HANDLE_T                     h_dvb_ctx,
                OPERA_HBBTV_VIDEO_REGION_T*  pt_src_reg,
                OPERA_HBBTV_VIDEO_REGION_T*  pt_dsp_reg);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_tune_svc_req
 *
 * Description: This function will tune to designated service (for opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_tune_svc_req(
                HANDLE_T                     h_dvb_ctx,
                OPERA_HBBTV_TUNE_SVC_INFO_T* pt_tune_req);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_dvb_get_curr_channel
 *
 * Description: This function get the current played service infomation (for opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_get_curr_channel(
            HANDLE_T                     h_dvb_ctx,
            OPERA_HBBTV_DVB_SVC_INFO_T*  pt_svc_info);


/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_set_visibility
 *
 * Description: This function set the broadcast video visibility(for opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_set_visibility(
                HANDLE_T            h_dvb_ctx,
                BOOL                b_visible,
                BOOL                b_unloaded);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_aud_mute
 *
 * Description: This function set the broadcast audio mute(for opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_aud_mute(
                HANDLE_T            h_dvb_ctx,
                BOOL  b_mute);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_set_volume
 *
 * Description: This function set the broadcast audio volume (for opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_set_volume(
                HANDLE_T            h_dvb_ctx,
                UINT8               ui1_volume);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_dvb_update_sbtl_status
 *
 * Description: This function will update subtitle select status (for Comp)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_update_sbtl_status(
        HANDLE_T                     h_dvb_ctx,
        OPERA_HBBTV_COMP_INTO_T*     pt_sbtl_comp, 
        OPERA_HBBTV_AV_COMP_EVENT_T  e_sbtl_status);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_select_comp
 *
 * Description: This function select/unselect designated av comp (for opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_select_comp(
                HANDLE_T                    h_dvb_ctx,
                OPERA_HBBTV_COMP_INTO_T*    pt_comp,
                BOOL                        b_select);
/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_tune_svc_req
 *
 * Description: This function update service change status to MW HBBTV DVB (for comp)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_svc_change_status(
                HANDLE_T                            h_dvb_ctx,
                OPERA_HBBTV_DVB_CHANGE_SVC_INFO_T*  pt_svc_change_info);
extern INT32 x_opera_hbbtv_delete_dsd_channel_from_svl(HANDLE_T h_dvb);
extern  INT32 x_opera_hbbtv_send_msg_to_dvb(
                                    HANDLE_T   h_dvb_ctx,
                                    UINT16    ui2_msg_type,
                                    VOID*      data,
                                    UINT32     data_length
                                    );
extern INT32 x_opera_hbbtv_create_dsd_channel(
                                    HANDLE_T     h_dvb_ctx,
                                    UINT8 * pc_delivery_sytem_descriptor,
                                    UINT32 ui4_dsd_length,
                                    INT32 i4_svid,
                                    UINT32 *pui4_ch_id
                                    );
extern INT32 x_opera_hbbtv_dvb_update_av_comp_status(HANDLE_T  h_dvb_ctx,
                            OPERA_HBBTV_COMP_INTO_T*     pt_comp,
                            OPERA_HBBTV_AV_COMP_EVENT_T  e_status);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_dvb_update_video_reg
 *
 * Description: This function will update video display region (for Comp)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_dvb_update_video_reg(HANDLE_T h_dvb_ctx);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_dvb_set_default_video_reg
 *
 * Description: This function will set video region to defalut value (for Comp)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_set_default_video_reg(HANDLE_T h_dvb_ctx);


/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_tune_svc_req
 *
 * Description: This function open a dvb contex (for comp)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_open(
                HANDLE_T*         ph_dvb_ctx,
                const CHAR*       ps_ctx_name,
                UINT16    ui2_svl_id);
extern INT32 x_opera_hbbtv_dvb_get_silent_channel_info(
                HANDLE_T        h_dvb_ctx,
                UINT16*         pui2_svl_rec_id,
                UINT32*         pui4_ch_id);
extern INT32 x_opera_hbbtv_send_msg_to_dvb(
                                    HANDLE_T   h_dvb_ctx,
                                    UINT16    ui2_msg_type,
                                    VOID*      data,
                                    UINT32     data_length
                                    );
/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_tune_svc_req
 *
 * Description: This function close dvb contex (for comp)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_close(HANDLE_T  h_dvb_ctx);


/*-----------------------------------------------------------------------------
 * Name: x_opear_hbbtv_get_svc_num
 *
 * Description: This function get number of service in current svl list (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_get_svc_num(
                HANDLE_T    h_dvb_ctx,
                UINT16 *    pui2_num_svc);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_get_all_svc_info
 *
 * Description: This function get all service info in current svl list (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

INT32 x_opera_hbbtv_get_all_svc_info(
            HANDLE_T                     h_dvb_ctx,
            OPERA_HBBTV_DVB_SVC_INFO_T*  pt_svc_head,
            UINT16                       ui2_svc_num);
/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_get_nw_num
 *
 * Description: This function get all service info in current svl list (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

INT32 x_opera_hbbtv_get_nw_num(
            HANDLE_T    h_dvb_ctx,
            UINT16 *    pui2_nw_nm);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_get_mds_auth_url
 *
 * Description: This function get all service info in current svl list (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

INT32 x_opera_hbbtv_get_mds_auth_url(
                       HANDLE_T                     h_dvb_ctx,
                       UINT16                       ui2_auth_num,
                       OPERA_HBBTV_DVB_AUTH_URL_T * pt_auth_head);


/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_get_svc_info_by_idx
 *
 * Description: This function get service info in current svl list with svc_idx (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_get_svc_info_by_idx (
                HANDLE_T                     h_dvb_ctx,
                UINT16                       ui2_idx, 
                OPERA_HBBTV_DVB_SVC_INFO_T*  pt_svc_info);
/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_get_svc_info_by_rec_id
 *
 * Description: This function get service info in current svl list with svc_rec_id (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_get_svc_info_by_rec_id(
                HANDLE_T                     h_dvb_ctx,
                UINT16                       ui2_svl_rec_id, 
                OPERA_HBBTV_DVB_SVC_INFO_T*  pt_svc_info); 



/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_set_resolution
 *
 * Description: This function set hbbtv broadcast resolution  (for Opera).
 *
 * Inputs: --
 *
 * Outputs: --
 *
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail.
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_set_resolution(UINT32 ui4_width, UINT32 ui4_height);
/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_dvb_get_comp_count
 *
 * Description: This function stream component count (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_get_comp_count(
        HANDLE_T                    h_dvb_ctx,
        UINT32                      ui4_comp_mask,
        UINT16*                     pui2_comp_count);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_dvb_get_comp_list
 *
 * Description: This function get stream comp list (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_dvb_get_comp_list(
        HANDLE_T                    h_dvb_ctx,
        UINT32                      ui4_comp_mask,
        OPERA_HBBTV_COMP_INTO_T*    pt_comp_list,
        UINT16                      ui2_comp_count);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_create_avcomponent
 *
 * Description: This function x_opera_hbbtv_create_avcomponent(for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail.
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

INT32 x_opera_hbbtv_create_avcomponent(HANDLE_T h_dvb_ctx,
                                       BRDCST_SET_STREAM_INFO_T *pt_stream_info,
                                       OPERA_HBBTV_COMP_INTO_T *pt_comp);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_get_dvb_ctx
 *
 * Description: This function get dvb_ctx handle (for Opera)
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_opera_hbbtv_get_dvb_ctx(HANDLE_T * ph_dvb_ctx);

/*-----------------------------------------------------------------------------
 * Name: x_hbbtv_dvb_programme_get_generic
 *
 * Description: This function used to get decriptor raw data
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/


extern INT32 x_hbbtv_dvb_programme_get_generic(
        UINT32 ui4_channel_id,
        UINT16 ui2_event_id,
        UINT8 ui1_tag,
        UINT8 ui1_tag_ext,
        CHAR* pc_eit_desc_buffer,
        UINT32* pui4_buffer_len);

/*-----------------------------------------------------------------------------
 * Name: x_opera_hbbtv_dvb_get_program_rating
 *
 * Description: This function used to get program rating
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/
extern INT32 x_opera_hbbtv_dvb_get_program_rating(
            HANDLE_T    h_dvb_ctx,
            UINT16      ui2_on_id,
            UINT16      ui2_ts_id,
            UINT16      ui2_svc_id,
            UINT16      ui2_event_id,
            UINT16*     pui2_channel_rating);

/*-----------------------------------------------------------------------------
 * Name: x_hbbtv_dvb_get_program_list
 *
 * Description: This function used to get specified channel programmes by start time 
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_hbbtv_dvb_get_program_list(
    UINT32                          ui4_channel_id, 
    TIME_T                          t_start, 
    TIME_T                          t_end, 
    UINT32                          ui4_max_prog, 
    UINT32 *                        ui4_num_prog, 
    OPERA_HBBTV_PROGRAM_LIST_T *    t_list);


/*-----------------------------------------------------------------------------
 * Name: x_hbbtv_dvb_search_program_list
 *
 * Description: This function used to search programmes by QueryTree 
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/


extern INT32 x_hbbtv_dvb_search_program_list(UINT8* pui1_serial_buffer,UINT32 ui4_token);

/*-----------------------------------------------------------------------------
 * Name: x_hbbtv_dvb_programme_list_get_total_size
 *
 * Description: This function used to get total result size . 
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_hbbtv_dvb_programme_list_get_total_size(UINT32* pui4_total_size);

/*-----------------------------------------------------------------------------
 * Name: x_hbbtv_dvb_programme_list_get_page
 *
 * Description: This function used to get specified page result. 
 *
 * Inputs: --
 *
 * Outputs: --
 *        
 * Returns:
 *        OPERA_HBBTVR_OK            The routine is successful.
 *        OPERA_HBBTVR_FAIL          The routine is fail. 
 *        OPERA_HBBTVR_INV_ARG   Indicates at least one argument is invalid
 * ----------------------------------------------------------------------------*/

extern INT32 x_hbbtv_dvb_programme_list_get_page( UINT32 ui4_page_number,
                                           UINT32 ui4_page_size,
                                           OPERA_HBBTV_PROGRAM_LIST_T* pt_prog_list,
                                           MD_SEARCH_NOTIFY    pv_callback,
                                           VOID*               pv_tag,
                                           UINT32*             pui4_got_event_number);


#endif


