/*----------------------------------------------------------------------------*
 * Copyright Statement:                                                       *
 *                                                                            *
 *   This software/firmware and related documentation ("MediaTek Software")   *
 * are protected under international and related jurisdictions'copyright laws *
 * as unpublished works. The information contained herein is confidential and *
 * proprietary to MediaTek Inc. Without the prior written permission of       *
 * MediaTek Inc., any reproduction, modification, use or disclosure of        *
 * MediaTek Software, and information contained herein, in whole or in part,  *
 * shall be strictly prohibited.                                              *
 * MediaTek Inc. Copyright (C) 2010. All rights reserved.                     *
 *                                                                            *
 *   BY OPENING THIS FILE, RECEIVER HEREBY UNEQUIVOCALLY ACKNOWLEDGES AND     *
 * AGREES TO THE FOLLOWING:                                                   *
 *                                                                            *
 *   1)Any and all intellectual property rights (including without            *
 * limitation, patent, copyright, and trade secrets) in and to this           *
 * Software/firmware and related documentation ("MediaTek Software") shall    *
 * remain the exclusive property of MediaTek Inc. Any and all intellectual    *
 * property rights (including without limitation, patent, copyright, and      *
 * trade secrets) in and to any modifications and derivatives to MediaTek     *
 * Software, whoever made, shall also remain the exclusive property of        *
 * MediaTek Inc.  Nothing herein shall be construed as any transfer of any    *
 * title to any intellectual property right in MediaTek Software to Receiver. *
 *                                                                            *
 *   2)This MediaTek Software Receiver received from MediaTek Inc. and/or its *
 * representatives is provided to Receiver on an "AS IS" basis only.          *
 * MediaTek Inc. expressly disclaims all warranties, expressed or implied,    *
 * including but not limited to any implied warranties of merchantability,    *
 * non-infringement and fitness for a particular purpose and any warranties   *
 * arising out of course of performance, course of dealing or usage of trade. *
 * MediaTek Inc. does not provide any warranty whatsoever with respect to the *
 * software of any third party which may be used by, incorporated in, or      *
 * supplied with the MediaTek Software, and Receiver agrees to look only to   *
 * such third parties for any warranty claim relating thereto.  Receiver      *
 * expressly acknowledges that it is Receiver's sole responsibility to obtain *
 * from any third party all proper licenses contained in or delivered with    *
 * MediaTek Software.  MediaTek is not responsible for any MediaTek Software  *
 * releases made to Receiver's specifications or to conform to a particular   *
 * standard or open forum.                                                    *
 *                                                                            *
 *   3)Receiver further acknowledge that Receiver may, either presently       *
 * and/or in the future, instruct MediaTek Inc. to assist it in the           *
 * development and the implementation, in accordance with Receiver's designs, *
 * of certain softwares relating to Receiver's product(s) (the "Services").   *
 * Except as may be otherwise agreed to in writing, no warranties of any      *
 * kind, whether express or implied, are given by MediaTek Inc. with respect  *
 * to the Services provided, and the Services are provided on an "AS IS"      *
 * basis. Receiver further acknowledges that the Services may contain errors  *
 * that testing is important and it is solely responsible for fully testing   *
 * the Services and/or derivatives thereof before they are used, sublicensed  *
 * or distributed. Should there be any third party action brought against     *
 * MediaTek Inc. arising out of or relating to the Services, Receiver agree   *
 * to fully indemnify and hold MediaTek Inc. harmless.  If the parties        *
 * mutually agree to enter into or continue a business relationship or other  *
 * arrangement, the terms and conditions set forth herein shall remain        *
 * effective and, unless explicitly stated otherwise, shall prevail in the    *
 * event of a conflict in the terms in any agreements entered into between    *
 * the parties.                                                               *
 *                                                                            *
 *   4)Receiver's sole and exclusive remedy and MediaTek Inc.'s entire and    *
 * cumulative liability with respect to MediaTek Software released hereunder  *
 * will be, at MediaTek Inc.'s sole discretion, to replace or revise the      *
 * MediaTek Software at issue.                                                *
 *                                                                            *
 *   5)The transaction contemplated hereunder shall be construed in           *
 * accordance with the laws of Singapore, excluding its conflict of laws      *
 * principles.  Any disputes, controversies or claims arising thereof and     *
 * related thereto shall be settled via arbitration in Singapore, under the   *
 * then current rules of the International Chamber of Commerce (ICC).  The    *
 * arbitration shall be conducted in English. The awards of the arbitration   *
 * shall be final and binding upon both parties and shall be entered and      *
 * enforceable in any court of competent jurisdiction.                        *
 *---------------------------------------------------------------------------*/
/*----------------------------------------------------------------------------*/
/*! @file x_sm_cc_isdb_hdlr.h 
 *  $RCSfile: $
 *  $Revision: #1 $
 *  $Date: 2015/11/26 $
 *  $Author: dtvbm11 $
 *  
 *  @par Description:
 *         This header file contains ISDB closed caption Stream handler specific 
 *         definitions, which are exported to applications.
 */
/*----------------------------------------------------------------------------*/

#ifndef _X_SM_CC_ISDB_HDLR_H_
#define _X_SM_CC_ISDB_HDLR_H_

/*----------------------------------------------------------------------------*/
/*! @addtogroup groupMW_STRM_MNGR_CCI_HDLR
*  @{  
*/
/*----------------------------------------------------------------------------*/

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/
#include "u_common.h"
#include "u_sm_cc_isdb_hdlr.h"


#define CC_ISDB_INIT_OK                 ((INT32) 0)    /**< The routine was successful */
#define CC_ISDB_INIT_FAIL               ((INT32) -1)    /**< The routine was fail */
extern BOOL  fg_g_cc_isdb_raw_data_is_utf8;


/*------------------------------------------------------------------*/
/*! @struct SM_CCI_CONFIG_T
 *  @brief  This structure contains the configuration data for ISDB closed caption stream handler
 *  @code
 *  typedef struct
 *  {
 *      UINT8                   ui1_wgl_order;
 *  }   SM_CCI_CONFIG_T;
 *  @endcode
 *  @li@c  ui1_wgl_order                                     - ISDB closed caption widget app order
 */
/*------------------------------------------------------------------*/
typedef struct
{
    UINT8                   ui1_wgl_order;
}   SM_CCI_CONFIG_T;

#if 0
typedef struct SM_CCI_HDLR_T
{
    
    HANDLE_T                h_hdlr_handle; 
    SM_CCI_SYS_SERVICE      t_sys_svc;  /* system serivce */
    HANDLE_T                h_wgl_app;
    UINT8                   ui1_wgl_order;
    
    SM_CCI_INSTANCE_T       at_cci_inst[SM_CCI_INST_TYPE_MODULE_NUM];
    //UINT8*                  pui1_demux_buf;/* demux buffer, both superimpose and caption will use the buffer */
}   SM_CCI_HDLR_T;
#endif

//SM_CCI_HDLR_T    t_g_cci_hdlr;

/*-----------------------------------------------------------------------------
                    functions declarations
-----------------------------------------------------------------------------*/
/*------------------------------------------------------------------*/
/*! @brief Initialize the ISDB closed caption configuration
 *  @param [in]     pt_config                   - Configuration context
 *  @param [out]
 *  @note
 *  @see
 *  @return     Return the error code.
 *  @retval      CC_ISDB_INIT_OK        - The routine was successful.
 *  @retval      CC_ISDB_INIT_FAIL      - The routine was fail.
 */
/*------------------------------------------------------------------*/
extern INT32 x_sm_cc_isdb_hdlr_init( SM_CCI_CONFIG_T*   pt_config );  


/*------------------------------------------------------------------*/
/*!@brief  This function is used to set the ISDB closed caption attributes.
 *  @param [in]    t_cci_att                    - ISDB CC attributes
 */
/*------------------------------------------------------------------*/
extern VOID x_sm_cc_isdb_hdlr_set_att( SM_CCI_ATTRIBS_T  t_cci_att );  

/*------------------------------------------------------------------*/
/*!@brief  This function is used to get the ISDB closed caption raw data is utf8?
 *  @param [in]    fg_is_utf8_data      - The utf8 flag
 */
/*------------------------------------------------------------------*/
extern VOID x_sm_cc_isdb_raw_data_is_utf8(BOOL  fg_is_utf8_data );

#endif /* _X_SM_CC_ISDB_HDLR_H_ */

/*----------------------------------------------------------------------------*/
/*! @} */                                            /* end of groupMW_STRM_MNGR_CCI_HDLR */
/*----------------------------------------------------------------------------*/



